@using System.ComponentModel
@using System.Drawing
@using System.Linq
@using System.Text;
@using AntDesign
@using AntDesign.TableModels
@using MatBlazor
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@page "/planetsearch"
@inject HttpClient Http
@inject NavigationManager NavManager
@inject ModalService modalService
@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject GlobalAppState GlobalAppState

<FIOWebServer.Components.LoadingWrapper @bind-ProgressCount="CurrentProgress" TotalProgress="4">
    <h1>Planet Search</h1>
    <em>Planet Data Refreshed Every 10 Minutes</em>
    <br/>
<Drawer Visible="@DrawerVisible" Placement="right" Title='("Show/Hide Columns")' OnClose="@(() => { DrawerVisible = false; StateHasChanged(); })">
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowFertility">Fertility</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowSurfaceType">Surface Type</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowGravity">Gravity</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowPressure">Pressure</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTemperature">Temperature</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowLM">LM</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowWAR">WAR</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowADM">ADM</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowSHY">SHY</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowCOGC">COGC</Checkbox></div>
    @for(int ExchangeIdx = 0; ExchangeIdx < ExchangeLocationNames.Count; ++ExchangeIdx)
    {
        int i = ExchangeIdx; // capture
        <div style="width:100%"><Checkbox Checked="@state.ShowExchangeJumps[i]" CheckedChange="@(()=>{state.ShowExchangeJumps[i] = !state.ShowExchangeJumps[i];})">@(ExchangeLocationNames[i]) Jumps</Checkbox></div>
    }
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowCurrency">Currency</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalPioneers">Total Pioneers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowUnemployedPioneers">Unemployed Pioneers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalSettlers">Total Settlers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowUnemployedSettlers">Unemployed Settlers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalTechnicians">Total Technicians</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowUnemployedTechnicians">Unemployed Technicians</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalEngineers">Total Engineers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowUnemployedEngineers">Unemployed Engineers</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalScientists">Total Scientists</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowUnemployedScientists">Unemployed Scientists</Checkbox></div>
    <div style="width:100%"><Checkbox @bind-Checked="@state.ShowTotalPlots">Total Plots</Checkbox></div>
</Drawer>

<div>
    <div class="flex-container" style="display: flex; flex-flow: row wrap; justify-content: flex-start; height: 25%; margin-bottom:10px">
        <div style="min-height:200px; min-width: 150px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                <b>Materials:</b>
                <Select
                Mode="multiple"
                @bind-Values="@state.SelectedMaterials"
                Placeholder="Select up to 4"
                TItemValue="string"
                TItem="string"
                Size="small"
                Style="width: 90%"
                EnableSearch
                AllowClear>
                    <SelectOptions>
                        @foreach(var planetMat in AllPlanetMaterials)
                        {
                            <SelectOption 
                            TItemValue="string" 
                            TItem="string" 
                            Value=@planetMat 
                            Label=@planetMat
                            Disabled="@(state.SelectedMaterials.Count() > 3 ? (state.SelectedMaterials.Contains(@planetMat) ? false : true) : false)"/>
                        }
                    </SelectOptions>
                </Select>
                <br/>
                <div>Concentration Threshold:
                    <Popover Title="" Placement="@Placement.BottomLeft">
                        <ContentTemplate>
                            <p>
                                When searching for resources on planets, filter out planets with concentrations<br/>
                                below this threshold.<br/><br/>
                                Set to 0% to show all results.
                            </p>
                        </ContentTemplate>
                        <ChildContent>
                            <MatIcon style="transform:scale(0.65)" Icon="info"/>
                        </ChildContent>
                    </Popover>
                    <br/>
                    <AntDesign.InputNumber @bind-Value="@ConcentrationThreshold" Formatter="ConcentrationThresholdFormatter" Parser="ConcentrationThresholdParser" DefaultValue="0d" Min="0" Max="100"></AntDesign.InputNumber>
                    <br/>
                    Production Efficiency:
                    <Popover Title="" Placement="@Placement.BottomLeft">
                        <ContentTemplate>
                            <p>
                                The efficiency to use when calculating daily extraction.
                            </p>
                        </ContentTemplate>
                        <ChildContent>
                            <MatIcon style="transform:scale(0.65)" Icon="info"/>
                        </ChildContent>
                    </Popover>
                    <br/>
                    <AntDesign.InputNumber @bind-Value="@ProductionEfficiency" Formatter="ProductionEfficiencyFormatter" Parser="ProductionEfficiencyParser" DefaultValue="100d" Min="0" Max="200"></AntDesign.InputNumber>
                    <br/>
                    <div style="align-self: flex-end; margin-top: 15px; margin-bottom: 15px; width: 100px; flex-grow: 0; flex-shrink: 0">
                        <div>
                            @if (SearchLoading)
                            {
                                <Spin size="large"/>
                            }
                        </div>
                    </div>
                </div> 
            </div>
        </div>
        <div style="min-height:200px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                <b>Planet Settings:</b>
                <div style="max-height: 200px; margin-right:10px; overflow-y:auto; width: fit-content">
                    <div><Checkbox Checked="@state.Fertile" CheckedChange="@(async () => {state.Fertile = !state.Fertile;await UpdateOnCheckedClick();})">Fertile</Checkbox></div>
                    <div><Checkbox Checked="@state.LM" CheckedChange="@(async () => {state.LM = !state.LM;await UpdateOnCheckedClick();})">Local Market</Checkbox></div>
                    <div><Checkbox Checked="@state.COGC" CheckedChange="@(async () => {state.COGC = !state.COGC;await UpdateOnCheckedClick();})">Chamber of Commerce</Checkbox></div>
                    <div><Checkbox Checked="@state.WAR" CheckedChange="@(async () => {state.WAR = !state.WAR;await UpdateOnCheckedClick();})">Warehouse</Checkbox></div>
                    <div><Checkbox Checked="@state.ADM" CheckedChange="@(async () => {state.ADM = !state.ADM;await UpdateOnCheckedClick();})">Administration Center</Checkbox></div>
                    <div><Checkbox Checked="@state.SHY" CheckedChange="@(async () => {state.SHY = !state.SHY;await UpdateOnCheckedClick();})">Shipyard</Checkbox></div>
                </div>
            </div>
        </div>
        <div style="min-height:200px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <div>
                <b>Match Planet Settings:</b>
                <Popover Title="" Placement="@Placement.BottomLeft">
                    <ContentTemplate>
                        <p>
                            At least one of these checkboxes must be checked.<br/>
                            Each checkbox effectively means you have access to that material and results will be filtered accordingly.<br/>
                            <br/>
                            See <a href="https://handbook.apex.prosperousuniverse.com/wiki/building-costs/#costs-calculation" target="_blank">building costs calculation section</a> in the handbook for more information.
                        </p>
                    </ContentTemplate>
                    <ChildContent>
                        <MatIcon style="transform:scale(0.65)" Icon="info"/>
                    </ChildContent>
                </Popover>
                <div style="max-height: 200px; margin-right:10px; overflow-y:auto; width: fit-content">
                    <div><Checkbox Checked="@state.Rocky" CheckedChange="@(async () => {state.Rocky = !state.Rocky; if (!state.Rocky && !state.Gaseous) { state.Rocky = true; } await UpdateOnCheckedClick();})">Rocky (MCG)</Checkbox></div>
                    <div><Checkbox Checked="@state.Gaseous" CheckedChange="@(async () => {state.Gaseous = !state.Gaseous; if (!state.Rocky && !state.Gaseous) { state.Gaseous = true; } await UpdateOnCheckedClick();})">Gaseous (AEF)</Checkbox></div>
                    <div><Checkbox Checked="@state.LowGravity" CheckedChange="@(async () => {state.LowGravity = !state.LowGravity;await UpdateOnCheckedClick();})">Low Gravity (MGC)</Checkbox></div>
                    <div><Checkbox Checked="@state.HighGravity" CheckedChange="@(async () => {state.HighGravity = !state.HighGravity;await UpdateOnCheckedClick();})">High Gravity (BL)</Checkbox></div>
                    <div><Checkbox Checked="@state.LowPressure" CheckedChange="@(async () => {state.LowPressure = !state.LowPressure;await UpdateOnCheckedClick();})">Low Pressure (SEA)</Checkbox></div>
                    <div><Checkbox Checked="@state.HighPressure" CheckedChange="@(async () => {state.HighPressure = !state.HighPressure;await UpdateOnCheckedClick();})">High Pressure (HSE)</Checkbox></div>
                    <div><Checkbox Checked="@state.LowTemperature" CheckedChange="@(async () => {state.LowTemperature = !state.LowTemperature;await UpdateOnCheckedClick();})">Low Temperature (INS)</Checkbox></div>
                    <div><Checkbox Checked="@state.HighTemperature" CheckedChange="@(async () => {state.HighTemperature = !state.HighTemperature;await UpdateOnCheckedClick();})">High Temperature (TSH)</Checkbox></div>
                    <div>
                        <Button Size="@ButtonSize.Small" OnClick="DefaultClicked">Default</Button>
                        <Button Size="@ButtonSize.Small" OnClick="SelectAllClicked">Select All</Button>
                    </div>
                    
                </div>
            </div>
        </div>
        <div style="min-height: 200px; margin-right:10px; width: fit-content; flex-grow: 0; flex-shrink: 0">
            <MatTable Items="@PlanetResources" class="mat-elevation-z5" ShowPaging="@(PlanetResources.Count > 4)" PageSize="4" UseSortHeaderRow="true" Striped="true" Style="font-size:11px">
                <MatTableHeader>
                    <MatSortHeaderRow SortChanged="@SortPlanetResources">
                        <MatSortHeader Style="font-size:12px" SortId="material">Material</MatSortHeader>
                        <MatSortHeader Style="font-size:12px" SortId="resourcetype"><span style="width:150px">Resource Type</span></MatSortHeader>
                        <MatSortHeader Style="font-size:12px" SortId="concentration">Concentration</MatSortHeader>
                        <MatSortHeader Style="font-size:12px" SortId="dailyextraction">
                            <span style="display:inline-block">
                                Daily Extraction 
                                <Popover Title="" Placement="@Placement.BottomLeft">
                                    <ContentTemplate>
                                        <p>
                                            Daily extraction is calculated assuming production efficiency specified
                                        </p>
                                    </ContentTemplate>
                                    <ChildContent>
                                        <MatIcon style="transform:scale(0.65)" Icon="info"/>
                                    </ChildContent>
                                </Popover>
                            </span>
                        </MatSortHeader>
                    </MatSortHeaderRow>
                </MatTableHeader>
                <MatTableRow>
                    <td>@context.Material</td>
                    <td >@context.ResourceType</td>
                    <td><span style="background-color:@(GetConcentrationColor(context))">@(context.IsValid ? context.Concentration.ToString("P2") : "")</span></td>
                    <td><span style="background-color:@(GetDailyExtractionColor(context))">@(context.IsValid ? (context.DailyExtraction * ProductionEfficiencyPercentage).ToString("N2") : "")</span></td>
                </MatTableRow>
            </MatTable>
        </div>
    </div>
    <div style="height: 75%; width:100%">
        <em>Click on a row to display planet details</em>
        <MatIconButton Style="outline:0" Icon="settings" OnClick="@(() => { DrawerVisible = true; })"></MatIconButton>
        <MatTable AllowSelection="true" SelectionChanged="PlanetSearchModelsSelectionChangedEvent" Items="@PlanetSearchModels" 
                    class="mat-elevation-z5" ShowPaging="true" @bind-PageSize="PlanetSearchPageSize" Striped="true" UseSortHeaderRow="true" Style="font-size:10px"
                    FilterByColumnName="DisplayName" DebounceMilliseconds="150">
            <MatTableHeader>
                <MatSortHeaderRow SortChanged="@SortPlanetSearchModels">
                    <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="planet">Planet</MatSortHeader>
                    @if (state.SelectedMaterials.Count() > 0) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="material0">@state.SelectedMaterials.ToList()[0]</MatSortHeader> }
                    @if (state.SelectedMaterials.Count() > 1) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="material1">@state.SelectedMaterials.ToList()[1]</MatSortHeader> }
                    @if (state.SelectedMaterials.Count() > 2) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="material2">@state.SelectedMaterials.ToList()[2]</MatSortHeader> }
                    @if (state.SelectedMaterials.Count() > 3) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="material3">@state.SelectedMaterials.ToList()[3]</MatSortHeader> }
                    @if (state.ShowFertility) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="fertility">Fertility</MatSortHeader> }
                    @if (state.ShowSurfaceType) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="surfacetype">Surface</MatSortHeader> }
                    @if (state.ShowGravity) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="gravity">Gravity</MatSortHeader> }
                    @if (state.ShowPressure) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="pressure">Pressure</MatSortHeader> }
                    @if (state.ShowTemperature) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="temperature">Temp</MatSortHeader> }
                    @if (state.ShowLM) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="lm">LM</MatSortHeader> }
                    @if (state.ShowWAR) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="war">WAR</MatSortHeader> }
                    @if (state.ShowADM) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="adm">ADM</MatSortHeader> }
                    @if (state.ShowSHY) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="shy">SHY</MatSortHeader> }
                    @if (state.ShowCOGC) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="cogc">COGC</MatSortHeader> }
                    @for(int ExchangeIdx = 0; ExchangeIdx < ExchangeLocationNames.Count; ++ExchangeIdx)
                    {
                        var i = ExchangeIdx; // capture
                        @if (state.ShowExchangeJumps[i]) { <MatSortHeader Style="font-size:11px; font-weight:bold" SortId="@($"{i}_jumps")"><span>Dist<br/>@(ExchangeLocationNames[i].Replace(" Station", ""))</span></MatSortHeader> }
                    }
                    @if (state.ShowCurrency) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="currency">Currency</MatSortHeader> }
                    @if (state.ShowTotalPioneers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totalpioneers">Total Pioneers</MatSortHeader> }
                    @if (state.ShowUnemployedPioneers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="unemployedpioneers">Unemployed Pioneers</MatSortHeader>  }
                    @if (state.ShowTotalSettlers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totalsettlers">Total Settlers</MatSortHeader> }
                    @if (state.ShowUnemployedSettlers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="unemployedsettlers">Unemployed Settlers</MatSortHeader> }
                    @if (state.ShowTotalTechnicians) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totaltechnicians">Total Technicians</MatSortHeader> }
                    @if (state.ShowUnemployedTechnicians) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="unemployedtechnicians">Unemployed Technicians</MatSortHeader> }
                    @if (state.ShowTotalEngineers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totalengineers">Total Engineers</MatSortHeader> }
                    @if (state.ShowUnemployedEngineers) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="unemployedengineers">Unemployed Engineers</MatSortHeader> }
                    @if (state.ShowTotalScientists) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totalscientists">Total Scientists</MatSortHeader> }
                    @if (state.ShowUnemployedScientists) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="unemployedscientists">Unemployed Scientists</MatSortHeader> }
                    @if (state.ShowTotalPlots) { <MatSortHeader Style="font-size:11px; font-weight:bold; text-align: center; vertical-align: middle" SortId="totalplots">Total Plots</MatSortHeader> }
                </MatSortHeaderRow>
            </MatTableHeader>
            <MatTableRow>
                <td style="width:125px">@context.DisplayName</td>
                @if (state.SelectedMaterials.Count() > 0)
                {
                    var material0 = state.SelectedMaterials.ToList()[0];
                    var res = context.Resources.Where(r => r.Material == material0).Select(r => r.DailyExtraction).FirstOrDefault();
                    if ( res != default(double) )
                    {
                        <td>@((res * ProductionEfficiencyPercentage).ToString("N2"))</td>
                    }
                    else
                    {
                        <td></td>
                    }
                }
                @if (state.SelectedMaterials.Count() > 1)
                {
                    var material1 = state.SelectedMaterials.ToList()[1];
                    var res = context.Resources.Where(r => r.Material == material1).Select(r => r.DailyExtraction).FirstOrDefault();
                    if ( res != default(double) )
                    {
                        <td>@((res * ProductionEfficiencyPercentage).ToString("N2"))</td>
                    }
                    else
                    {
                        <td></td>
                    }
                }
                @if (state.SelectedMaterials.Count() > 2)
                {
                    var material2 = state.SelectedMaterials.ToList()[2];
                    var res = context.Resources.Where(r => r.Material == material2).Select(r => r.DailyExtraction).FirstOrDefault();
                    if ( res != default(double) )
                    {
                        <td>@((res * ProductionEfficiencyPercentage).ToString("N2"))</td>
                    }
                    else
                    {
                        <td></td>
                    }
                }
                @if (state.SelectedMaterials.Count() > 3)
                {
                    var material3 = state.SelectedMaterials.ToList()[3];
                    var res = context.Resources.Where(r => r.Material == material3).Select(r => r.DailyExtraction).FirstOrDefault();
                    if ( res != default(double) )
                    {
                        <td>@((res * ProductionEfficiencyPercentage).ToString("N2"))</td>
                    }
                    else
                    {
                        <td></td>
                    }
                }
                @if (state.ShowFertility)
                {
                    <td><span hidden="@(!context.IsFertile)">@(context.Fertility > 0.0f ? "+" : "")@(context.Fertility.ToString("P2"))</span></td>
                }
                @if (state.ShowSurfaceType)
                {
                     <td>@context.SurfaceType</td>
                }
                @if (state.ShowGravity)
                {
                    <td>
                    @switch(context.Gravity)
                    {
                        case "Low":
                            <Tag Style="font-size:10px" Color="blue">Low</Tag>
                            break;
                        case "High":
                            <Tag Style="font-size:10px" Color="red">High</Tag>
                            break;
                        case "Normal":
                            <Tag Style="font-size:10px" Color="green">Normal</Tag>
                            break;
                    }
                    </td>
                }
                @if (state.ShowPressure)
                {
                    <td>
                    @switch(context.Pressure)
                    {
                        case "Low":
                            <Tag Style="font-size:10px" Color="blue">Low</Tag>
                            break;
                        case "High":
                            <Tag Style="font-size:10px" Color="red">High</Tag>
                            break;
                        case "Normal":
                            <Tag Style="font-size:10px" Color="green">Normal</Tag>
                            break;
                    }
                    </td>
                }
                @if (state.ShowTemperature)
                {
                    <td>
                        @switch(context.Temperature)
                        {
                            case "Low":
                                <Tag Style="font-size:10px" Color="blue">Low</Tag>
                                break;
                            case "High":
                                <Tag Style="font-size:10px" Color="red">High</Tag>
                                break;
                            case "Normal":
                                <Tag Style="font-size:10px" Color="green">Normal</Tag>
                                break;
                        }
                    </td>
                }
                @if (state.ShowLM)
                {
                    <td><Checkbox Checked="@context.HasLocalMarket" CheckedChange="@(() => {context.HasLocalMarket=context.HasLocalMarket;})"/></td>
                }
                @if (state.ShowWAR)
                {
                    <td><Checkbox Checked="@context.HasWarehouse" CheckedChange="@(() => {context.HasWarehouse=context.HasWarehouse;})"/></td>
                }
                @if (state.ShowADM)
                {
                    <td><Checkbox Checked="@context.HasAdministrationCenter" CheckedChange="@(() => {context.HasAdministrationCenter=context.HasAdministrationCenter;})"/></td>
                }
                @if (state.ShowSHY)
                {
                    <td><Checkbox Checked="@context.HasShipyard" CheckedChange="@(() => {context.HasShipyard=context.HasShipyard;})"/></td>
                }
                @if (state.ShowCOGC)
                {
                    <td>
                        @switch(context.ActiveCOGCDisplay)
                        {
                            case "Inactive":
                                <em>@context.ActiveCOGCDisplay</em>
                                break;
                            case "No Data":
                                <Popover Title="">
                                    <ContentTemplate>
                                        <p>COGC data for this planet is not available.  If you have the FIO extension, please open up a buffer for <a href="" @onclick="@(() => { _ = CopyToClipboard($"COGC {context.PlanetNaturalId}"); })" @onclick:preventDefault >COGC @(context.PlanetNaturalId)</a> to refresh the data.</p>
                                    </ContentTemplate>
                                    <ChildContent>
                                        <b><a href="" style="color:black; text-decoration:none; background-color:orange" @onclick="@(() => { _ = CopyToClipboard($"COGC {context.PlanetNaturalId}"); })" @onclick:preventDefault>@context.ActiveCOGCDisplay</a></b>
                                    </ChildContent>
                                </Popover>
                                
                                break;
                            default:
                                @context.ActiveCOGCDisplay
                                break;
                        }
                    </td>
                }
                @for(int ExchangeIdx = 0; ExchangeIdx < ExchangeLocationNames.Count; ++ExchangeIdx)
                {
                    var i = ExchangeIdx; //capture
                    @if (state.ShowExchangeJumps[i]) 
                    { 
                        <td>@context.DistanceResults[i]</td>
                    }
                }
                @if (state.ShowCurrency)
                {
                    <td>@context.CurrencyCode</td>
                }
                @if (state.ShowTotalPioneers)
                {
                    <td>@context.TotalPioneers</td>     
                }
                @if (state.ShowUnemployedPioneers)
                {
                    <td>@context.OpenPioneers</td>  
                }
                @if (state.ShowTotalSettlers)
                {
                    <td>@context.TotalSettlers</td>  
                }
                @if (state.ShowUnemployedSettlers)
                {
                    <td>@context.OpenSettlers</td>    
                }
                @if (state.ShowTotalTechnicians)
                {
                    <td>@context.TotalTechnicians</td>
                }
                @if (state.ShowUnemployedTechnicians)
                {
                    <td>@context.OpenTechnicians</td> 
                }
                @if (state.ShowTotalEngineers)
                {
                    <td>@context.TotalEngineers</td>
                }
                @if (state.ShowUnemployedEngineers)
                {
                    <td>@context.OpenEngineers</td>   
                }
                @if (state.ShowTotalScientists)
                {
                    <td>@context.TotalScientists</td> 
                }
                @if (state.ShowUnemployedScientists)
                {
                    <td>@context.OpenScientists</td>  
                }
                @if (state.ShowTotalPlots)
                {
                    <td>@context.TotalPlots</td>
                }
            </MatTableRow>
        </MatTable>
    </div>
</div>
</FIOWebServer.Components.LoadingWrapper>